84a0ad96875e115aeb33d381f7e75deb565158b1
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         array-init.cs           \
48         arraylist.cs            \
49         assemblyresolve_event.cs        \
50         assemblyresolve_event3.cs       \
51         checked.cs              \
52         char-isnumber.cs        \
53         create-instance.cs      \
54         field-layout.cs         \
55         pack-layout.cs          \
56         pack-bug.cs             \
57         hash-table.cs           \
58         test-ops.cs             \
59         obj.cs                  \
60         test-dup-mp.cs          \
61         string.cs               \
62         stringbuilder.cs        \
63         switch.cs               \
64         outparm.cs              \
65         delegate.cs             \
66         bitconverter.cs         \
67         exception.cs            \
68         exception2.cs           \
69         exception3.cs           \
70         exception4.cs           \
71         exception5.cs           \
72         exception6.cs           \
73         exception7.cs           \
74         exception8.cs           \
75         exception10.cs          \
76         exception11.cs          \
77         exception12.cs          \
78         exception13.cs          \
79         exception14.cs          \
80         exception15.cs          \
81         exception16.cs          \
82         exception17.cs          \
83         typeload-unaligned.cs   \
84         struct.cs               \
85         valuetype-gettype.cs    \
86         typeof-ptr.cs           \
87         static-constructor.cs   \
88         pinvoke.cs              \
89         pinvoke2.cs             \
90         pinvoke3.cs             \
91         pinvoke11.cs            \
92         pinvoke13.cs            \
93         pinvoke17.cs            \
94         invoke.cs               \
95         invoke2.cs              \
96         runtime-invoke.cs               \
97         invoke-string-ctors.cs          \
98         reinit.cs               \
99         box.cs                  \
100         array.cs                \
101         enum.cs                 \
102         enum2.cs                \
103         property.cs             \
104         enumcast.cs             \
105         assignable-tests.cs     \
106         array-cast.cs           \
107         array-subtype-attr.cs   \
108         cattr-compile.cs        \
109         cattr-field.cs          \
110         cattr-object.cs         \
111         custom-attr.cs          \
112         double-cast.cs          \
113         newobj-valuetype.cs     \
114         arraylist-clone.cs      \
115         setenv.cs               \
116         vtype.cs                \
117         isvaluetype.cs          \
118         iface6.cs               \
119         iface7.cs               \
120         ipaddress.cs            \
121         array-vt.cs             \
122         interface1.cs           \
123         reflection-enum.cs      \
124         reflection-prop.cs      \
125         reflection4.cs          \
126         reflection5.cs          \
127         reflection-const-field.cs \
128         many-locals.cs          \
129         string-compare.cs       \
130         test-prime.cs           \
131         params.cs               \
132         reflection.cs           \
133         interface.cs            \
134         iface.cs                \
135         iface2.cs               \
136         iface3.cs               \
137         iface4.cs               \
138         iface-large.cs          \
139         virtual-method.cs       \
140         intptrcast.cs           \
141         indexer.cs              \
142         stream.cs               \
143         console.cs              \
144         shift.cs                \
145         jit-int.cs              \
146         jit-uint.cs             \
147         jit-long.cs             \
148         long.cs                 \
149         jit-ulong.cs            \
150         jit-float.cs            \
151         pop.cs                  \
152         time.cs                 \
153         appdomain.cs        \
154         appdomain1.cs           \
155         appdomain2.cs           \
156         appdomain-client.cs     \
157         appdomain-unload.cs \
158         appdomain-async-invoke.cs       \
159         loader.cs       \
160         pointer.cs              \
161         hashcode.cs             \
162         delegate1.cs            \
163         delegate2.cs            \
164         delegate3.cs            \
165         delegate5.cs            \
166         delegate6.cs            \
167         delegate7.cs            \
168         delegate8.cs            \
169         delegate9.cs            \
170         remoting1.cs            \
171         remoting2.cs            \
172         remoting3.cs            \
173         remoting4.cs            \
174         remoting5.cs            \
175         largeexp.cs             \
176         largeexp2.cs            \
177         marshalbyref1.cs        \
178         static-ctor.cs          \
179         inctest.cs              \
180         bound.cs                \
181         array-invoke.cs         \
182         test-arr.cs             \
183         decimal.cs              \
184         decimal-array.cs        \
185         marshal.cs              \
186         marshal1.cs             \
187         marshal2.cs             \
188         marshal3.cs             \
189         marshal5.cs             \
190         marshal6.cs             \
191         marshal7.cs             \
192         marshal8.cs             \
193         marshal9.cs             \
194         marshalbool.cs          \
195         marshal-valuetypes.cs   \
196         test-byval-in-struct.cs \
197         thread.cs               \
198         thread5.cs              \
199         thread6.cs              \
200         thread-static.cs        \
201         thread-static-init.cs   \
202         context-static.cs       \
203         float-pop.cs            \
204         interfacecast.cs        \
205         array3.cs               \
206         classinit.cs            \
207         classinit2.cs           \
208         synchronized.cs         \
209         async_read.cs           \
210         threadpool.cs           \
211         threadpool1.cs          \
212         threadpool-exceptions1.cs \
213         threadpool-exceptions2.cs \
214         threadpool-exceptions3.cs \
215         threadpool-exceptions4.cs \
216         threadpool-exceptions5.cs \
217         threadpool-exceptions6.cs \
218         threadpool-exceptions7.cs \
219         base-definition.cs      \
220         bug-27420.cs            \
221         bug-47295.cs            \
222         bug-46781.cs            \
223         bug-48015.cs            \
224         bug-42136.cs            \
225         bug-59286.cs            \
226         bug-70561.cs            \
227         bug-78311.cs            \
228         bug-78653.cs            \
229         bug-78656.cs            \
230         bug-77127.cs            \
231         bug-323114.cs           \
232         bug-Xamarin-5278.cs     \
233         interlocked.cs          \
234         cross-domain.cs         \
235         appdomain-exit.cs       \
236         delegate-async-exit.cs  \
237         delegate-delegate-exit.cs       \
238         delegate-exit.cs        \
239         finalizer-abort.cs      \
240         finalizer-exception.cs  \
241         finalizer-exit.cs       \
242         finalizer-thread.cs     \
243         main-exit.cs    \
244         main-returns-abort-resetabort.cs        \
245         main-returns-background-abort-resetabort.cs     \
246         main-returns-background-resetabort.cs   \
247         main-returns-background.cs      \
248         main-returns-background-change.cs       \
249         main-returns.cs         \
250         subthread-exit.cs       \
251         desweak.cs              \
252         cominterop.cs           \
253         exists.cs               \
254         handleref.cs    \
255         transparentproxy.cs \
256         dbnull-missing.cs       \
257         test-type-ctor.cs       \
258         soft-float-tests.cs     \
259         thread-exit.cs          \
260         finalize-parent.cs      \
261         assemblyresolve_event2.2.cs     \
262         interlocked-2.2.cs      \
263         pinvoke-2.2.cs          \
264         bug-78431.2.cs          \
265         bug-79684.2.cs          \
266         catch-generics.2.cs     \
267         event-get.2.cs          \
268         safehandle.2.cs         \
269         stackframes-async.2.cs          \
270         module-cctor-loader.2.cs        \
271         generics-invoke-byref.2.cs      \
272         generic-signature-compare.2.cs  \
273         generics-sharing.2.cs   \
274         shared-generic-methods.2.cs     \
275         shared-generic-synchronized.2.cs        \
276         generic-inlining.2.cs   \
277         generic-initobj.2.cs    \
278         generic-delegate.2.cs   \
279         generic-sizeof.2.cs     \
280         generic-virtual.2.cs    \
281         generic-interface-methods.2.cs  \
282         generic-array-type.2.cs \
283         generic-method-patching.2.cs    \
284         generic-static-methods.2.cs     \
285         generic-null-call.2.cs  \
286         generic-special.2.cs    \
287         generic-exceptions.2.cs \
288         generic-virtual2.2.cs   \
289         generic-valuetype-interface.2.cs        \
290         generic-getgenericarguments.2.cs        \
291         generic-type-builder.2.cs       \
292         generic-synchronized.2.cs       \
293         generic-delegate-ctor.2.cs      \
294         generic-array-iface-set.2.cs    \
295         generic-typedef.2.cs    \
296         generic-marshalbyref.2.cs       \
297         generic-xdomain.2.cs    \
298         bug-431413.2.cs \
299         bug-459285.2.cs \
300         generic-virtual-invoke.2.cs     \
301         bug-461198.2.cs \
302         generic-sealed-virtual.2.cs     \
303         generic-system-arrays.2.cs      \
304         generic-stack-traces.2.cs       \
305         generic-stack-traces2.2.cs      \
306         bug-472600.2.cs \
307         recursive-generics.2.cs \
308         bug-473482.2.cs \
309         bug-473999.2.cs \
310         bug-479763.2.cs \
311         bug-616463.cs   \
312         bug-80392.2.cs          \
313         dynamic-method-access.2.cs      \
314         dynamic-method-finalize.2.cs    \
315         bug-82194.2.cs  \
316         anonarray.2.cs  \
317         ienumerator-interfaces.2.cs     \
318         array-enumerator-ifaces.2.cs    \
319         generic_type_definition_encoding.2.cs \
320         generic_type_definition.2.cs    \
321         bug-333798.2.cs         \
322         bug-333798-tb.2.cs              \
323         bug-335131.2.cs         \
324         bug-322722_patch_bx.2.cs                \
325         bug-348522.2.cs         \
326         bug-340662_bug.cs       \
327         bug-322722_dyn_method_throw.2.cs        \
328         bug-389886-2.cs \
329         bug-325283.2.cs \
330         thunks.cs \
331         winx64structs.cs \
332         bug-349190.2.cs \
333         nullable_boxing.2.cs    \
334         valuetype-equals.cs     \
335         custom-modifiers.2.cs   \
336         bug-382986.cs   \
337         test-inline-call-stack.cs       \
338         bug-324535.cs   \
339         modules.cs      \
340         bug-81673.cs    \
341         bug-81691.cs    \
342         bug-80307.cs    \
343         bug-415577.cs   \
344         filter-stack.cs \
345         vararg2.cs      \
346         bug-389886-sre-generic-interface-instances.cs   \
347         bug-461867.cs   \
348         bug-461941.cs   \
349         bug-461261.cs   \
350         bug-400716.cs   \
351         bug-462592.cs   \
352         bug-459094.cs   \
353         generic-unloading.2.cs  \
354         generic-unloading-sub.2.cs      \
355         bug-467456.cs   \
356         appdomain-unload-callback.cs    \
357         bug-508538.cs   \
358         bug-472692.2.cs         \
359         gchandles.cs    \
360         interlocked-3.cs        \
361         interlocked-4.2.cs      \
362         finalizer-wait.cs       \
363         critical-finalizers.cs  \
364         appdomain-thread-abort.cs \
365         xdomain-threads.cs      \
366         w32message.cs   \
367         bug-544446.cs   \
368         gc-altstack.cs  \
369         large-gc-bitmap.cs      \
370         bug-561239.cs   \
371         bug-562150.cs   \
372         bug-575941.cs   \
373         bug-599469.cs   \
374         bug-389886-3.cs \
375         monitor.cs      \
376         dynamic-method-resurrection.cs  \
377         bug-666008.cs   \
378         bug-685908.cs   \
379         sgen-long-vtype.cs      \
380         delegate-invoke.cs      \
381         bug-696593.cs   \
382         bug-705140.cs   \
383         bug-1147.cs     \
384         mono-path.cs    \
385         bug-bxc-795.cs  \
386         bug-3903.cs     \
387         async-with-cb-throws.cs \
388         appdomain-unload-doesnot-raise-pending-events.cs        \
389         bug-6148.cs
390
391 TEST_CS_SRC_DIST=       \
392         $(BASE_TEST_CS_SRC)     \
393         async-exc-compilation.cs \
394         filter-stack.cs \
395         finally_guard.cs
396
397 TEST_CS_SRC_GEN = \
398         runtime-invoke.gen.cs \
399         imt_big_iface_test.cs
400
401 if AMD64
402 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
403 # #651684
404 PLATFORM_DISABLED_TESTS = finally_guard.exe
405 else
406 if X86
407 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
408 else
409 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
410 endif
411 endif
412
413 if IA64
414 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
415 # bug #319249
416 PLATFORM_DISABLED_TESTS=exception17.exe
417 PLATFORM_DISABLED_TESTS+=winx64structs.exe
418 endif
419
420 if X86
421
422 if HOST_WIN32
423 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
424 endif
425
426 endif
427
428 if POWERPC
429 # bug #71274
430 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
431 endif
432
433 if ARM
434 PLATFORM_DISABLED_TESTS=filter-stack.exe
435 endif
436
437 if MIPS
438 # monitor.exe is racy
439 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
440 endif
441
442 if S390x
443 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
444 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
445 endif
446
447 # The two finalizer tests only work under sgen
448 # gc-altstack.exe fails under boehm because it has no support for altstack
449 # bug-459094.exe creates an extremely deep directory tree
450 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
451 # reverted.
452 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
453 DISABLED_TESTS=                 \
454         delegate-async-exception.exe    \
455         bug-348522.2.exe        \
456         finalizer-wait.exe      \
457         critical-finalizers.exe \
458         gc-altstack.exe \
459         bug-459094.exe \
460         delegate-invoke.exe \
461         generic_type_definition.2.exe \
462         $(PLATFORM_DISABLED_TESTS)
463
464 DISABLED_TESTS_WRENCH=  \
465         $(DISABLED_TESTS)       \
466         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
467         main-returns-background-resetabort.exe \
468         main-returns-background-abort-resetabort.exe    \
469         main-returns-background.exe     \
470         thread6.exe     \
471         assemblyresolve_event3.exe \
472         delegate2.exe   \
473         finally_guard.exe       \
474         finalizer-abort.exe     \
475         finalizer-exit.exe      \
476         finalizer-thread.exe \
477         appdomain-async-invoke.exe
478
479 AOT_DISABLED_TESTS=constraints-load.exe
480
481 # These only compile with MS CSC
482 TEST_CSC_SRC=                   \
483         vararg.cs
484
485 TEST_IL_SRC=                    \
486         field-access.il         \
487         method-access.il        \
488         ldftn-access.il         \
489         cpblkTest.il            \
490         vbinterface.il          \
491         calliTest.il            \
492         ckfiniteTest.il         \
493         fault-handler.il                \
494         locallocTest.il         \
495         initblkTest.il          \
496         qt-instance.il          \
497         vararg.il               \
498         bug-29859.il            \
499         bug-78549.il            \
500         static-fields-nonconst.il       \
501         reload-at-bb-end.il     \
502         test-enum-indstoreil.il \
503         filter-bug.il           \
504         even-odd.il             \
505         bug-82022.il    \
506         vt-sync-method.il       \
507         enum_types.il   \
508         invalid-token.il        \
509         call_missing_method.il  \
510         call_missing_class.il   \
511         ldfld_missing_field.il  \
512         ldfld_missing_class.il  \
513         find-method.2.il        \
514         bug-79215.2.il  \
515         bug-79956.2.il  \
516         bug-327438.2.il \
517         bug-387274.2.il \
518         bug-426309.2.il \
519         ldtoken_with_byref_typespec.2.il \
520         resolve_method_bug.2.il \
521         resolve_field_bug.2.il \
522         resolve_type_bug.2.il   \
523         generics-sharing-other-exc.2.il \
524         generic-ldobj.2.il      \
525         generic-mkrefany.2.il   \
526         generic-refanyval.2.il  \
527         generic-ldtoken.2.il    \
528         generic-ldtoken-method.2.il     \
529         generic-ldtoken-field.2.il      \
530         generic-tailcall.2.il   \
531         generic-tailcall2.2.il  \
532         generic-array-exc.2.il  \
533         generic-valuetype-newobj2.2.il  \
534         generic-valuetype-newobj.2.il   \
535         generic-constrained.2.il        \
536         generic-type-load-exception.2.il        \
537         bug-81466.il    \
538         bug457574.il    \
539         bug445361.il    \
540         bug-463303.il   \
541         bug469742.2.il  \
542         bug-528055.il   \
543         constraints-load.il     \
544         array_load_exception.il \
545         bug-481403.il   \
546         interface-with-static-method.il \
547         bug-515884.il   \
548         bug-633291.il   \
549         delegate-with-null-target.il    \
550         bug-318677.il
551
552 # pre-requisite test sources: files that are not test themselves
553 # but that need to be compiled
554 PREREQ_IL_SRC=event-il.il module-cctor.il
555 PREREQ_CS_SRC=
556 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
557 PREREQ_CS_DLL_SRC=
558
559 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
560 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
561 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
562 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
563 TESTBS=$(BENCHSRC:.cs=.exe)
564 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
565
566 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
567         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
568
569 %.exe: %.il
570         $(ILASM) -out:$@ $<
571
572 %.exe: %.cs TestDriver.dll
573         $(MCS) -r:TestDriver.dll -out:$@ $<
574
575 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
576 if POWERPC
577 test_platform:
578 else
579 # Can't use mkbundle on win32 since there is no static build there
580 # Can't run test-unhandled-exception on Windows because of all the debug popups...
581 if HOST_WIN32
582 test_platform:
583 else
584 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
585 #test_platform: testbundle test-iomap-regression
586 test_platform:  test-iomap-regression
587 endif
588 endif
589
590 if X86
591 if HOST_WIN32
592 else
593 test_platform: test-eglib-remap
594 endif
595 endif
596
597 # Target to precompile the test executables
598 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
599
600 #
601 # Test that no symbols are missed in eglib-remap.h
602 #
603 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
604 test-eglib-remap:
605         @echo "Testing eglib remap..."
606         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
607
608 #
609 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
610 # code that checks that the table is properly sorted
611 #
612 test-messages: w32message.exe
613         > test_messages.zero
614         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
615
616 if MOONLIGHT
617 test_2_1 : test-coreclr-security
618 else
619 test_2_1 :
620 endif
621
622 if AMD64
623 test-sgen : sgen-tests
624 else
625 if X86
626 test-sgen : sgen-tests
627 else
628 if ARM
629 test-sgen : sgen-tests
630 else
631 if S390x
632 test-sgen : sgen-regular-tests
633 endif
634 endif
635 endif
636 endif
637
638 test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test-messages
639 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
640
641 # Remove empty .stdout and .stderr files for wrench
642 rm-empty-logs:
643         @echo "Removing empty logs..."
644         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
645
646 assemblyresolve/test/asm.dll:
647         $(MAKE) -C assemblyresolve prereq
648
649 TestDriver.dll:
650         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
651
652 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
653         @failed=0; \
654         passed=0; \
655         for i in $(TESTSI_CS); do       \
656                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
657                 then \
658                         passed=`expr $${passed} + 1`; \
659                 else \
660                         if [ $$? = 2 ]; then break; fi; \
661                         failed=`expr $${failed} + 1`; \
662                 fi \
663         done; \
664         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
665
666 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
667         @failed=0; \
668         passed=0; \
669         for i in $(TESTSI_IL); do       \
670                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
671                 then \
672                         passed=`expr $${passed} + 1`; \
673                 else \
674                         if [ $$? = 2 ]; then break; fi; \
675                         failed=`expr $${failed} + 1`; \
676                 fi \
677         done; \
678         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
679
680 testb: $(TEST_PROG) $(TESTBS)
681         for i in $(TESTBS); do  \
682                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
683         done
684
685 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
686         @failed=0; \
687         passed=0; \
688         failed_tests="";\
689         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
690                 rm -f $${i}.so; \
691                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
692                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' $(RUNTIME_ARGS); \
693                 then \
694                         passed=`expr $${passed} + 1`; \
695                 else \
696                         if [ $$? = 2 ]; then break; fi; \
697                         failed=`expr $${failed} + 1`; \
698                         failed_tests="$${failed_tests} $$i"; \
699                 fi \
700         done; \
701         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
702         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
703           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
704
705 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
706         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
707
708 testjit-wrench:
709         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
710
711 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
712         @failed=0; \
713         passed=0; \
714         failed_tests="";\
715         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
716                 rm -f $${i}.so; \
717                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
718                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
719                 then \
720                         passed=`expr $${passed} + 1`; \
721                 else \
722                         if [ $$? = 2 ]; then break; fi; \
723                         failed=`expr $${failed} + 1`; \
724                         failed_tests="$${failed_tests} $$i"; \
725                 fi \
726         done; \
727         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
728         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
729           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
730
731 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
732         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
733
734 testjit:
735         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
736
737 testaot:
738         @$(MAKE) AOT=1 runtest
739
740 testtrace:
741         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
742
743 testinterp:
744         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
745
746 testjitspeed: $(JITTEST_PROG) $(TESTBS)
747         for i in $(TESTBS); do  \
748                 echo $$i;       \
749                 time $(JITTEST_PROG) $$i;       \
750         done
751
752 test-iomap-regression: exists.cs
753         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
754         @echo "Testing exists.exe..."
755         @MONO_IOMAP=all $(RUNTIME) exists.exe
756
757 stresstest: $(STRESS_TESTS)
758         @failed=0; \
759         passed=0; \
760         failed_tests="";\
761         for i in $(STRESS_TESTS); do    \
762                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
763                 then \
764                         passed=`expr $${passed} + 1`; \
765                 else \
766                         if [ $$? = 2 ]; then break; fi; \
767                         failed=`expr $${failed} + 1`; \
768                         failed_tests="$${failed_tests} $$i"; \
769                 fi \
770         done; \
771         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
772         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
773           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
774
775 testbundle: console.exe
776         @echo "Testing mkbundle..."
777         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
778         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
779         @- rm -rf a.out
780
781 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
782 test-type-load: TestDriver.dll
783         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
784         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
785         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
786         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
787         @echo "Testing load-exception.exe..."
788         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
789
790
791 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs
792
793 SGEN_TESTS =    \
794         sgen-descriptors.exe    \
795         sgen-gshared-vtype.exe
796
797 sgen-regular-tests: $(SGEN_TESTS)
798         @for fn in $+ ; do      \
799                 echo "Testing $$fn ...";        \
800                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
801                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
802                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
803                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
804                 MONO_GC_PARAMS=major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;    \
805                 MONO_GC_PARAMS=minor=split,major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;        \
806                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
807                 MONO_GC_PARAMS=minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
808         done
809
810
811 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
812         @echo "Testing sgen-bridge.exe ...";    \
813         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;      \
814         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;  \
815         echo "Testing sgen-bridge-major-fragmentation.exe ..."; \
816         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;  \
817         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;
818
819
820 # Generated tests for runtime invoke
821 EXTRA_DIST += gen-runtime-invoke.cs
822 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
823         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
824         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
825
826 EXTRA_DIST += make-imt-test.cs
827 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
828         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
829         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
830
831 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
832 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
833         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
834 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
835         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
836
837 EXTRA_DIST += unhandled-exception-base-configuration.config
838 EXTRA_DIST += unhandled-exception-legacy-configuration.config
839 EXTRA_DIST += appdomain-unload.exe.config
840 EXTRA_DIST += unhandled-exception-test-case.2.cs
841 EXTRA_DIST += unhandled-exception-test-runner.2.cs
842 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
843         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
844 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
845         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
846 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
847         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
848 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
849         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
850         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
851         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
852         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
853 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
854         $(MCS) /debug unhandled-exception-test-case.1.cs
855 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
856         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
857 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
858         $(MCS) /debug unhandled-exception-test-case.2.cs
859 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
860         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
861 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
862         $(MCS) /debug unhandled-exception-test-runner.2.cs
863
864 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
865         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
866
867 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
868 bug-80307.exe: $(srcdir)/bug-80307.cs
869         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
870         cd $(top_builddir)/runtime && $(MAKE) test-support-files
871
872 EXTRA_DIST += bug-81673-interface.cs
873 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
874         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
875         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
876         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
877
878 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
879 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
880         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
881         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
882         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
883         rm -f bug-81691-a.dll
884 bug-81691.exe: bug-81691-b.dll
885
886 EXTRA_DIST += bug-81466-lib.il
887 bug-81466-lib.dll: bug-81466-lib.il
888         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
889 bug-81466.exe: bug-81466.il bug-81466-lib.dll
890         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
891
892 EXTRA_DIST += bug-324535-il.il
893 bug-324535-il.dll : bug-324535-il.il
894         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
895 bug-324535.exe : bug-324535.cs bug-324535-il.dll
896         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
897
898 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
899 custom-modifiers-lib.dll: custom-modifiers-lib.il
900         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
901 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
902         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
903
904 EXTRA_DIST += bug-382986-lib.cs
905 bug-382986-lib.dll: bug-382986-lib.cs
906         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
907 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
908         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
909
910 EXTRA_DIST += coreclr-security.cs
911
912 if MOONLIGHT
913 coreclr-security.exe : coreclr-security.cs
914         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
915
916 test-coreclr-security : coreclr-security.exe
917         @echo "Testing coreclr-security.exe..."
918         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
919 endif
920
921 EXTRA_DIST += generic-unboxing.2.il
922 generic-unboxing.2.dll : generic-unboxing.2.il
923         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
924
925 EXTRA_DIST += generic-boxing.2.il
926 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
927         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
928
929 EXTRA_DIST += generic-unbox.2.cs
930 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
931         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
932
933 EXTRA_DIST += generic-box.2.cs
934 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
935         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
936
937 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
938 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
939         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
940 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
941         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
942
943 bug-3903.exe: bug-3903.cs
944         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
945
946 gshared: test-generic-sharing
947
948 gshared-aot:
949         @$(MAKE) AOT=1 gshared
950
951 GSHARED_TESTS = \
952                 generics-sharing.2.exe shared-generic-methods.2.exe     \
953                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
954                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
955                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
956                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
957                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
958                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
959                 generic-virtual.2.exe generic-tailcall.2.exe                    \
960                 generic-interface-methods.2.exe generic-array-type.2.exe        \
961                 generic-method-patching.2.exe generic-static-methods.2.exe      \
962                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
963                 generic-array-exc.2.exe generic-special.2.exe                   \
964                 generic-exceptions.2.exe generic-delegate2.2.exe                \
965                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
966                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
967                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
968                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
969                 generic-constrained.2.exe bug-431413.2.exe                      \
970                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
971                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
972                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
973                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
974                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
975                 bug-479763.2.exe generic-xdomain.2.exe                          \
976                 generic-type-load-exception.2.exe bug-616463.exe        \
977                 bug-1147.exe
978
979 test-generic-sharing-normal: $(GSHARED_TESTS)
980         @for fn in $+ ; do      \
981                 echo "Testing $$fn ...";        \
982                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
983                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
984                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
985                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
986                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
987         done
988
989 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
990         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
991
992 test-generic-sharing:
993         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
994
995 EXTRA_DIST += async-exceptions.cs
996 async-exceptions.exe : async-exceptions.cs
997         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
998 test-async-exceptions : async-exceptions.exe
999         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1000         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1001
1002 EXTRA_DIST += modules.cs modules-m1.cs
1003 modules-m1.netmodule: modules-m1.cs
1004         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1005 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1006         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1007
1008 # Useful if mono is compiled with --enable-shared=no
1009 patch-libtool:
1010         cp "../../libtool" .
1011         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1012         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1013         touch libtest.c
1014
1015 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1016 test-process-exit:
1017         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1018         @echo "Testing bug-438454.exe..."
1019         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1020         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1021
1022 OOM_TESTS =     \
1023         gc-oom-handling.exe     \
1024         gc-oom-handling2.exe
1025
1026
1027 test-oom: $(OOM_TESTS)
1028         @for fn in $+ ; do      \
1029                 echo "Testing $$fn ...";        \
1030                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1031                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1032                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1033         done
1034
1035
1036 noinst_LTLIBRARIES = libtest.la
1037
1038 INCLUDES = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1039
1040 if HOST_WIN32
1041 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1042 # This shows up when compiling mono_test_marshal_delegate ()
1043 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1044 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1045 # can't find them. So we use --kill-at to remove the @ suffix as well.
1046 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1047 else
1048 libtest_la_LDFLAGS = -rpath `pwd`
1049 endif
1050 libtest_la_SOURCES = libtest.c
1051 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1052
1053 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat